<template>
	<div class="app-container">
		<el-form :model="queryParams" ref="queryRef" :inline="true" label-width="68px">
		    <el-form-item label="公司名称" prop="corporateName">
		        <el-input v-model="queryParams.corporateName" placeholder="请输入公司名称" clearable
		            @keyup.enter="handleQuery" />
		    </el-form-item>
			<el-form-item label="联系人" prop="contacts">
			    <el-input v-model="queryParams.contacts" placeholder="请输入联系人" clearable
			        @keyup.enter="handleQuery" />
			</el-form-item>
		    <el-form-item>
		        <el-button type="primary" icon="Search" @click="handleQuery">搜索
		        </el-button>
		        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
		    </el-form-item>
		</el-form>
		<el-row :gutter="10" class="mb8">
		    <el-col :span="1.5">
		        <el-button type="primary" plain icon="Plus" @click="handleAdd"
		            v-hasPermi="['customer:customer:add']">新增
		        </el-button>
		    </el-col>
		    <el-col :span="1.5">
		        <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete"
		            v-hasPermi="['customer:customer:remove']">删除
		        </el-button>
		    </el-col>
		    <el-col :span="1.5">
		        <el-button type="warning" plain icon="Download" @click="handleExport"
		            v-hasPermi="['customer:customer:export']">导出
		        </el-button>
		    </el-col>
		</el-row>
		<el-table v-loading="loading" :data="customerList" @selection-change="handleSelectionChange">
		    <el-table-column type="selection" width="55" align="center" />
		    <el-table-column label="公司名称" align="center" prop="corporateName" />
		    <el-table-column label="联系人" align="center" prop="contacts"/>
		    <el-table-column label="联系电话" align="center" prop="contactNumber" />
		    <el-table-column label="公司地址" align="center" prop="companyAddress" />
		    <el-table-column label="操作" align="center" class-name="small-padding fixed-width" width="200" fixed="right">
		        <template #default="scope">
		            <el-button link type="success" icon="Edit" @click="handleUpdate(scope.row)"
		                v-hasPermi="['customer:customer:edit']">修改
		            </el-button>
		            <el-button link type="danger" icon="Delete" @click="handleDelete(scope.row)"
		                v-hasPermi="['customer:customer:remove']">删除
		            </el-button>
					<el-button link type="primary" icon="Tickets" @click="handleDelete(scope.row)"
					    v-hasPermi="['customer:customer:list']">订单
					</el-button>
		        </template>
		    </el-table-column>
		</el-table>
		<pagination v-show="total>0" :total="total" v-model:page="queryParams.pageNum"
		    v-model:limit="queryParams.pageSize" @pagination="getList" />
		<!-- 添加或修改证书对话框 -->
		<el-dialog :title="title" v-model="open" width="500px" append-to-body>
		    <el-form ref="customerRef" :model="customerForm" :rules="rules" label-width="120px">
		        <el-form-item label="公司名称" prop="corporateName">
		            <el-input v-model="customerForm.corporateName" placeholder="请输入公司名称" />
		        </el-form-item>
		        <el-form-item label="联系人" prop="contacts">
		            <el-input v-model="customerForm.contacts" placeholder="请输入联系人" />
		        </el-form-item>
		        <el-form-item label="联系电话" prop="contactNumber">
		            <el-input v-model="customerForm.contactNumber" placeholder="请输入联系电话" maxlength="11"/>
		        </el-form-item>
				<el-form-item label="公司地址" prop="companyAddress">
				    <el-input v-model="customerForm.companyAddress" type="textarea" :rows="2" placeholder="请输入公司地址" />
				</el-form-item>
		    </el-form>
		    <template #footer>
		        <div class="dialog-footer">
		            <el-button type="primary" @click="submitForm">确 定</el-button>
		            <el-button @click="cancel">取 消</el-button>
		        </div>
		    </template>
		</el-dialog>
	</div>
</template>

<script setup>
	const { proxy } = getCurrentInstance();
	const customerList = ref([]);
	const ids = ref([]);
	const single = ref(true);
	const multiple = ref(true);
	const open = ref(false);
	const loading = ref(true);
	const total = ref(0);
	const title = ref("");
	const data = reactive({
	    customerForm: {},
	    queryParams: {
	        pageNum: 1,
	        pageSize: 10,
	        corporateName: null,
	        contacts: null
	    },
	    rules: {
	        corporateName: [{
				required: true, message: "公司名称不能为空", trigger: "blur"
			}],
	        contacts: [{
				required: true, message: "联系人不能为空", trigger: "blur"
			}],
	        contactNumber: [{ 
				required: true, message: "联系电话不能为空", trigger: "blur" },{
				required: true, pattern: /^1[3|4|5|6|7|8|9][0-9]\d{8}$/, message: "请输入正确的联系电话", trigger: "blur" 
			}],
	        companyAddress: [{
				required: true, message: "公司地址不能为空", trigger: "blur"
			}]
	    }
	});
	const { queryParams, customerForm, rules } = toRefs(data);
	/** 查询证书列表 */
	function getList() {
	    loading.value = true;
	    // listCertificate(queryParams.value).then(response => {
	        // customerList.value = response.rows;
	        // total.value = response.total;
			customerList.value = [{
				corporateId:12,
				corporateName:"易站智联科技（广州）有限公司",
				contacts:"陈志朋",
				contactNumber:"13570960169",
				companyAddress:"广东省广州市天河区天顺路粤港澳大湾区创新创业孵化基地B栋413"
			}];
			total.value = 1;
	        loading.value = false;
	    // });
		
	}
	getList();
	/** 搜索按钮操作 */
	function handleQuery() {
	    queryParams.value.pageNum = 1;
	    getList();
	}
	
	/** 重置按钮操作 */
	function resetQuery() {
	    proxy.resetForm("queryRef");
	    handleQuery();
	}
	// 多选框选中数据
	function handleSelectionChange(selection) {
	    ids.value = selection.map(item => item.corporateId);
	    single.value = selection.length != 1;
	    multiple.value = !selection.length;
	}
	/** 删除按钮操作 */
	function handleDelete(row) {
	    const corporateIds = row.corporateId || ids.value;
	    proxy.$modal.confirm('是否确认删除客户编号为"' + corporateIds + '"的数据项？').then(function () {
	        // return delCertificate(corporateIds);
	    }).then(() => {
	        getList();
	        proxy.$modal.msgSuccess("删除成功");
	    }).catch(() => { });
	}
	// 取消按钮
	function cancel() {
	    open.value = false;
	    reset();
	}
	// 表单重置
	function reset() {
	    customerForm.value = {
	        corporateId:null,
	        corporateName:null,
	        contacts:null,
	        contactNumber:null,
	        companyAddress:null
	    };
	    proxy.resetForm("customerRef");
	}
	/** 新增按钮操作 */
	function handleAdd() {
	    reset();
	    open.value = true;
	    title.value = "添加客户信息";
	}
	
	/** 修改按钮操作 */
	function handleUpdate(row) {
	    reset();
	    const corporateId = row.corporateId || ids.value
	    // getCertificate(corporateId).then(response => {
	    //     customerForm.value = response.data;
			customerForm.value = row;
	        open.value = true;
	        title.value = "修改客户信息";
	    // });
	}
	/** 提交按钮 */
	function submitForm() {
	    proxy.$refs["customerRef"].validate(valid => {
	        if (valid) {
	            if (customerForm.value.corporateId != null) {
	                // updateCertificate(customerForm.value).then(response => {
	                    proxy.$modal.msgSuccess("修改成功");
	                    open.value = false;
	                    getList();
	                // });
	            } else {
	                // addCertificate(customerForm.value).then(response => {
	                    proxy.$modal.msgSuccess("新增成功");
	                    open.value = false;
	                    getList();
	                // });
	            }
	        }
	    });
	}
	/** 导出按钮操作 */
	function handleExport() {
	    // downloadCertificate(queryParams.value)
	}
</script>

<style>
</style>